import java.awt.*;
import java.awt.event.*;
import com.sun.java.swing.*;
import com.sun.java.swing.border.*;
import com.sun.java.accessibility.*;

public class menu_swing extends JFrame {

  headPanel tp;
  menuPanel mp;
  selectPanel sp;
  bottomPanel bp;

  LoginDialog loginDialog;
  Timer timer;
  graphs aGraph;

  //JButton stopButton;

  String AccessQuery = "select count (RemoteHost) from Access_Logs where ";
  String aDayCountAllQuery = " from AccessCount where ";
  String DailyCountAllQuery = "select AllCount from AccessCount where ";
  String condition;
  String timeCondition;
  String query;
  String title = "Default";
  String aDay;
  String aMonth;
  String aYear;
  String fromDay = "8";
  String toDay = "14";
  private String whichDB = "Default";

  static boolean isHourly = false;
  static boolean isDaily = false;
  static boolean isAll = false;
  static boolean isDBOpen = false;

  public final static int ONE_SECOND = 1000;

  public static void main(String argv[]) {
    JFrame frame = new menu_swing();

    WindowListener l = new WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        System.exit(0);
      }
    };
    frame.addWindowListener(l);

    frame.setTitle("Dynamic Statistics");
    frame.setSize(460, 460);
    frame.setResizable(false);
    //frame.setBackground(Color.white);
    //frame.pack();
    frame.setVisible(true);
  }
  
  public menu_swing() {
    super("menu_swing");

    JMenuBar menuBar;
    JMenu dbMenu;
    JRadioButtonMenuItem rbMenuItem;
    MenuListener dbMenuListener;

    aGraph = new graphs(this);

    tp = new headPanel();
    mp = new menuPanel(this);
    sp = new selectPanel();
    bp = new bottomPanel(this);

    Container contentPane = getContentPane();
    //contentPane.setLayout(new BoxLayout(contentPane, BoxLayout.Y_AXIS));
    contentPane.setLayout(new GridLayout(4, 0, 0, 5));
    //-contentPane.setBackground(Color.white);
    contentPane.add(tp);
    contentPane.add(mp);
    contentPane.add(sp);
    contentPane.add(bp);

    //contentPane.validate();

    timer = new Timer(ONE_SECOND, new TimerListener());

    menuBar = new JMenuBar();
    setJMenuBar(menuBar);

    dbMenu = new JMenu("DB selection");
    menuBar.add(dbMenu);

    //stopButton = new JButton("Stop");
    //ButtonListener sbuttonListener = new ButtonListener();
    //stopButton.addActionListener(sbuttonListener);
    //stopButton.setBackground(Color.red);
    //stopButton.setEnabled(false);
    //menuBar.add(stopButton);

    ButtonGroup dbGroup = new ButtonGroup();
    dbMenuListener = new MenuListener(this);

    rbMenuItem = new JRadioButtonMenuItem("Default");
    rbMenuItem.setSelected(true);
    dbGroup.add(rbMenuItem);
    rbMenuItem.addActionListener(dbMenuListener);
    dbMenu.add(rbMenuItem);

    rbMenuItem = new JRadioButtonMenuItem("Illustra");
    dbGroup.add(rbMenuItem);
    rbMenuItem.addActionListener(dbMenuListener);
    dbMenu.add(rbMenuItem);

    rbMenuItem = new JRadioButtonMenuItem("Oracle");
    dbGroup.add(rbMenuItem);
    rbMenuItem.addActionListener(dbMenuListener);
    dbMenu.add(rbMenuItem);
  }

  public void changeArea(String area) {
    System.out.println("Change to "+area);
    ((CardLayout)sp.areaP.getLayout()).show(sp.areaP, area);
    if (area == "Site") { setMessage("Please type a site name."); }
    else if (area == "Domain") { setMessage("Please choose a domain."); }
    else if (area == "Page")
      { setMessage("Please type a page. (Prefix for including subdirectories)"); }
  }

  public void changeDate(String date) {
    System.out.println("Change to "+date);
    ((CardLayout)sp.dateP.getLayout()).show(sp.dateP, date);
  }

  public void setisHourly() {
    isHourly = true;
    isDaily = false;
  }

  public void setisDaily() {
    isDaily = true;
    isHourly = false;
  }

  public void setCondition(int sel, String input) {
    if ( sel == 0 ) {
      condition = null;
      timeCondition = null;
      isAll = false;
    }
    else if ( sel == 1 ) {
      if (condition != null) condition = input + condition;
      else condition = input;
    }
    else if ( sel == 2 ) {
      if (condition == null)
        System.out.println("Condition has only date information");
      else {
        if (isAll) {
	  condition = condition + "AccessDate ";
        }
	else {
	  condition = condition + " and AccessDate between ";
	}
        timeCondition = input;
      }
    }
    else { System.out.println("Error: Illegal selection in setCondition."); }
  }

  public void getCondition() {
    String select;

    select = mp.spaceP.whichSpace;
    //aYear = sp.aYear.getText();
    //System.out.println("*****************************CurrentMonth:" + aMonth);

    if (select.equals("Site")) {
      setCondition(1, "RemoteHost = '" + sp.siteP.getCondition() + "'");
      title = "SiteGraph";
      System.out.println("Site is on");
    }
    else if (select.equals("Domain")) {
      String country;
      country = sp.domainP.getCondition();
      if (country.equals("All")) {
        isAll = true;
	setCondition(1, " ");
      }
      else {
        setCondition(1, "Country = '" + sp.domainP.getCondition() + "'");
      }
      title = "CountryGraph";
      System.out.println("Domain is on");
    }
    else if (select.equals("Page")) {
      if (sp.pageP.IsPrefix()) {
        setCondition(1, "AccessPage like '" + sp.pageP.getCondition() + "%'");
      }
      else {
        setCondition(1, "AccessPage = '" + sp.pageP.getCondition() + "'");
      }
      title = "PageGraph";
      System.out.println("Page is on");
    }

    select = mp.timeP.whichPeriod;
    if (select.equals("A Day Hourly")) {
      setisHourly();
      aDay = getDate(sp.aDate.getText());
      aMonth = sp.currentMonth;
      aYear = sp.aYear.getText();
      setCondition(2, aMonth + " " + aDay + " " + aYear);
      if (isAll) {
        query = aDayCountAllQuery + condition + " ";
      }
      else {
        query = AccessQuery + condition + " ";
      }
    }
    else if (select.equals("Daily Within a Month")) {
      setisDaily();
      fromDay = getDate(sp.fromDate.getText());
      toDay = getDate(sp.toDate.getText());
      aMonth = sp.currentMonth;
      aYear = sp.fromYear.getText();
      System.out.println("from " +fromDay+" to "+toDay);
      setCondition(2, aMonth + " ");
      if (isAll) {
        query = DailyCountAllQuery + condition;
      }
      else {
        query = AccessQuery + condition;
      }
    }

    System.out.println("Condition: \"" + condition + "\".");
  }

  public String getDate(String day) {
    return day.trim();
  }

  public void execution() {
    System.out.println("execution!!!");
    getCondition();
    setMessage("Making a graph file");
    if (isHourly) {
      //aGraph = new graphs(this, query, timeCondition, "Hourly"+title);
      if (getWhichDB() == "Default") {
        aGraph.setBooleanDB("Oracle");
        aGraph.openDB("", "", "");
      }
      timer.start();     
      aGraph.go(query, timeCondition, "Hourly"+title);
    }
    else if (isDaily) {
      //aGraph = new graphs(this, query, "Daily"+title, fromDay, toDay);
      timer.start();
      aGraph.go(query, "Daily"+title, fromDay, toDay);
    }
    //setCondition(0, "");
    //setMessage("Please close the graph window for other selection.", Color.blue);
    setProgressBar(0);
  }

  public void setMessage(String aMessage) {
    tp.message.setText(aMessage);
  }

  public void setMessage(String aMessage, Color aColor) {
    tp.message.setForeground(aColor);
    tp.message.setText(aMessage);
  }

  public void showMessageDialog(String aMessage) {
    JOptionPane.showMessageDialog(this, aMessage, "Warning", JOptionPane.WARNING_MESSAGE);
  }

  public void setProgressBar(int value) {
    bp.barP.pBar.setValue(value);
  }

  public void setWhichDB(String db) {
    whichDB = db;
    aGraph.setBooleanDB(db);
  }

  public String getWhichDB() {
    return whichDB;
  }

  public void setDBOpen(boolean b) {
    isDBOpen = b;
  }

  class MenuListener implements ActionListener {
    menu_swing parent;

    MenuListener (menu_swing target) {
      this.parent = target;
    }

    public void actionPerformed(ActionEvent e) {
      if (isDBOpen) {
        aGraph.closeDB();
      }
      JMenuItem source = (JMenuItem)(e.getSource());
      setWhichDB( source.getText() );
      System.out.println(getWhichDB() + " is selected.");
      if (getWhichDB() == "Default") {
        aGraph.openDB("", "", "");
      }
      else {
        loginDialog = new LoginDialog(parent);
        loginDialog.pack();
        loginDialog.setLocationRelativeTo(parent);
        loginDialog.show();
        String[] s = loginDialog.getValidatedText();
        if (s != null) {
          System.out.println("Login Info " + s[0] + " " + s[1] + " " + s[2]);
          aGraph.openDB(s[0], s[1], s[2]);
        }
      }
    }
  }

  /*class ButtonListener implements ActionListener { 
    public void actionPerformed(ActionEvent e) {
      System.out.println("Stop Button");
      aGraph.stop();
    }
  }*/

  class TimerListener implements ActionListener {
    public void actionPerformed(ActionEvent ent) {
      setProgressBar(aGraph.getCurrent());
      if (aGraph.done()) {
        timer.stop();
      }
    }
  }
}

class headPanel extends JPanel {
  JTextField message;

  public headPanel() {
    System.out.println("HeadPanel");
    //-setBackground(Color.white);
    GridBagLayout gb = new GridBagLayout();
    GridBagConstraints c = new GridBagConstraints();
    setLayout(gb);

    c.fill = GridBagConstraints.BOTH;

    c.gridheight = 2;
    c.gridwidth = GridBagConstraints.REMAINDER;   
    JPanel tp = new JPanel();
    tp.setFont(new Font("TimesRoman", Font.BOLD, 38));
    Label title = new Label("Statistics");
    tp.add(title);
    gb.setConstraints(tp, c);
    add(tp);

    c.gridheight = 1;
    JPanel mp = new JPanel();
    //mp.setBorder(BorderFactory.createEtchedBorder());
    //mp.setBackground(Color.white);
    //mp.setFont(new Font("Courier", Font.PLAIN, 12));
    message = new JTextField("Welcome to NPAC Statistics", 30);
    message.setEditable(false);
    message.setBackground(Color.white);
    message.setForeground(Color.blue);
    message.setFont(new Font("Helvetica", Font.PLAIN, 12));
    message.setBorder(BorderFactory.createLoweredBevelBorder());
    mp.add(message);
    gb.setConstraints(mp, c);
    add(mp);
  }
}

class menuPanel extends JPanel {
  menu_swing parent;
  spacePanel spaceP;
  timePanel timeP;

  public menuPanel(menu_swing parent) {
    System.out.println("MenuPanel");
    this.parent = parent;
    //-setBackground(Color.white);
    setBorder(BorderFactory.createEmptyBorder(5, 50, 5, 50));
    setLayout(new GridLayout(0, 2, 40, 5));

    spaceP = new spacePanel(this);
    timeP = new timePanel(this);

    add(spaceP);
    add(timeP);
  }
}

class spacePanel extends JPanel {
  menuPanel parent;
  ButtonGroup spaceG;
  String whichSpace;

  public spacePanel(menuPanel parent) {
    this.parent = parent;
    //-setBackground(Color.white);
    setLayout(new GridLayout(3,0,2,2));

    Border blackline = BorderFactory.createLineBorder(Color.black);
    TitledBorder spaceTitle = BorderFactory.createTitledBorder(blackline, "Field");
    spaceTitle.setTitleJustification(TitledBorder.CENTER);
    setBorder(spaceTitle);

    spaceG = new ButtonGroup();

    whichSpace = "Site";
    JRadioButton siteButton = new JRadioButton("Site", true);
    JRadioButton domainButton = new JRadioButton("Domain", false);
    JRadioButton pageButton = new JRadioButton("Page", false);

    RadioListener spaceListener = new RadioListener();

    siteButton.addActionListener(spaceListener);
    domainButton.addActionListener(spaceListener);
    pageButton.addActionListener(spaceListener);

    spaceG.add(siteButton);
    spaceG.add(domainButton);
    spaceG.add(pageButton);

    add(siteButton);
    add(domainButton);
    add(pageButton);
  }

  class RadioListener implements ActionListener { 
    public void actionPerformed(ActionEvent e) {
      String select;
      select = e.getActionCommand();
      System.out.println("space Button: " + select);
      whichSpace = select;
      parent.parent.changeArea(select);
    }
  }
}

class timePanel extends JPanel {
  menuPanel parent;
  ButtonGroup timeG;
  String whichPeriod;

  public timePanel(menuPanel parent) {
    this.parent = parent;
    //-setBackground(Color.white);
    setLayout(new GridLayout(2,0,2,2));

    Border blackline = BorderFactory.createLineBorder(Color.black);
    TitledBorder timeTitle = BorderFactory.createTitledBorder(blackline, "Period");
    timeTitle.setTitleJustification(TitledBorder.CENTER);
    setBorder(timeTitle);

    timeG = new ButtonGroup();

    whichPeriod = "A Day Hourly";
    JRadioButton dayButton = new JRadioButton("A Day Hourly", true);
    JRadioButton weekButton = new JRadioButton("Daily Within a Month", false);

    RadioListener timeListener = new RadioListener();

    dayButton.addActionListener(timeListener);
    weekButton.addActionListener(timeListener);

    timeG.add(dayButton);
    timeG.add(weekButton);

    add(dayButton);
    add(weekButton);
  }

  class RadioListener implements ActionListener { 
    public void actionPerformed(ActionEvent e) {
      String select;
      select = e.getActionCommand();
      System.out.println("time Button: " + select);
      whichPeriod = select;
      parent.parent.changeDate(select);
    }
  }
}

class selectPanel extends JPanel {
  JPanel areaP;
  JPanel dateP;

  sitePanel siteP;
  domainPanel domainP;
  pagePanel pageP;

  JTextField aYear;
  JTextField fromYear;
  JTextField aDate;
  JTextField fromDate;
  JTextField toDate;

  String currentMonth = "Jun";

  public selectPanel() {
    System.out.println("SelectPanel");
    //-setBackground(Color.white);
    setLayout(new GridLayout(2, 0, 0, 5));

    /*Border blackline = BorderFactory.createLineBorder(Color.black);
    TitledBorder selectTitle = BorderFactory.createTitledBorder(blackline, "Selection");
    selectTitle.setTitleJustification(TitledBorder.LEFT);
    setBorder(selectTitle);*/

    areaP = new JPanel();
    areaP.setLayout(new CardLayout());

    siteP = new sitePanel(this);
    domainP = new domainPanel(this);
    pageP = new pagePanel(this);

    areaP.add("Site", siteP);
    areaP.add("Domain", domainP);
    areaP.add("Page", pageP);
    //((CardLayout)areaP.getLayout()).show(areaP, "site");

    dateP = new JPanel();
    dateP.setLayout(new CardLayout());

    JPanel twoP;
    twoP = new JPanel();
    twoP.setLayout(new FlowLayout(FlowLayout.CENTER, 5, 0));

    fromYear = new JTextField("1998", 4);

    JComboBox fromMonth;
    fromMonth = new JComboBox();
    fromMonth.addItem("Jan");
    fromMonth.addItem("Feb");
    fromMonth.addItem("Mar");
    fromMonth.addItem("Apr");
    fromMonth.addItem("May");
    fromMonth.addItem("Jun");
    fromMonth.addItem("Jul");
    fromMonth.addItem("Aug");
    fromMonth.addItem("Sep");
    fromMonth.addItem("Oct");
    fromMonth.addItem("Nov");
    fromMonth.addItem("Dec");
    fromMonth.setSelectedIndex(5);

    ComboListener fromMonthListener = new ComboListener();
    fromMonth.addActionListener(fromMonthListener);

    fromDate = new JTextField(" 8", 2);
    JLabel aSpace = new JLabel(" ,  ");
    toDate = new JTextField("14", 2);
    twoP.add(fromYear);
    twoP.add(fromMonth);
    twoP.add(fromDate);
    twoP.add(aSpace);
    twoP.add(toDate);

    Border empty = BorderFactory.createEmptyBorder();
    TitledBorder twoTitle = BorderFactory.createTitledBorder(empty, "Type periods");
    twoTitle.setTitleJustification(TitledBorder.CENTER);
    twoP.setBorder(twoTitle);

    JPanel oneP;
    oneP = new JPanel();
    oneP.setLayout(new FlowLayout(FlowLayout.CENTER, 5, 0));

    aYear = new JTextField("1998", 4);

    JComboBox aMonth;
    aMonth = new JComboBox();
    aMonth.addItem("Jan");
    aMonth.addItem("Feb");
    aMonth.addItem("Mar");
    aMonth.addItem("Apr");
    aMonth.addItem("May");
    aMonth.addItem("Jun");
    aMonth.addItem("Jul");
    aMonth.addItem("Aug");
    aMonth.addItem("Sep");
    aMonth.addItem("Oct");
    aMonth.addItem("Nov");
    aMonth.addItem("Dec");
    aMonth.setSelectedIndex(5);

    ComboListener aMonthListener = new ComboListener();
    aMonth.addActionListener(aMonthListener);

    aDate = new JTextField(" 8", 2);
    oneP.add(aYear);
    oneP.add(aMonth);
    oneP.add(aDate);

    //Border empty = BorderFactory.createEmptyBorder();
    TitledBorder oneTitle = BorderFactory.createTitledBorder(empty, "Type a date");
    oneTitle.setTitleJustification(TitledBorder.CENTER);
    oneP.setBorder(oneTitle);

    dateP.add("A Day Hourly", oneP);
    dateP.add("Daily Within a Month", twoP);

    add(areaP);
    add(dateP);
  }
  
  class ComboListener implements ActionListener {
    public void actionPerformed(ActionEvent e) {
      JComboBox cb = (JComboBox)e.getSource();
      String newMonth = (String)cb.getSelectedItem();
      currentMonth = newMonth;
    }
  }
}

class sitePanel extends JPanel {
  selectPanel parent;
  JTextField site;

  static int siteColumns = 20;

  public sitePanel(selectPanel target) {
    this.parent = target;
    //setBackground(Color.white);
    //setLayout(new FlowLayout(FlowLayout.CENTER, 5, 20));

    Border empty = BorderFactory.createEmptyBorder();
    TitledBorder siteTitle = BorderFactory.createTitledBorder(empty, "Type a site");
    siteTitle.setTitleJustification(TitledBorder.CENTER);
    setBorder(siteTitle);

    site = new JTextField("crawl3.atext.com", siteColumns);
    add(site);
  }

  public String getCondition() {
    return site.getText();
  }
}

class domainPanel extends JPanel {
  selectPanel parent;
  JComboBox domain;
  String country = "All";

  public domainPanel(selectPanel target) {
    this.parent = target;
    setLayout(new FlowLayout(FlowLayout.CENTER, 5, 0));

    Border empty = BorderFactory.createEmptyBorder();
    TitledBorder domainTitle = BorderFactory.createTitledBorder(empty, "Choose a domain");
    domainTitle.setTitleJustification(TitledBorder.CENTER);
    setBorder(domainTitle);

    domain = new JComboBox();
    domain.addItem("All");
    domain.addItem("US Educational");
    domain.addItem("US Commercial");
    domain.addItem("US Military");
    domain.addItem("Network");
    domain.addItem("United States");
    domain.addItem("Canada");
    domain.addItem("United Kingdom");
    domain.addItem("Sweden");
    domain.addItem("Japan");
    domain.addItem("Italy");
    domain.addItem("Germany");
    domain.addItem("France");
    domain.addItem("Norway");
    domain.addItem("Australia");

    ComboListener domainListener = new ComboListener();
    domain.addActionListener(domainListener);

    add(domain);
  }

  public void setCountry(String newCountry) {
    country = newCountry;
  }

  public String getCondition() {
    return country;
  }

  class ComboListener implements ActionListener {
    public void actionPerformed(ActionEvent e) {
      setCountry((String)domain.getSelectedItem());
    }
  }
}

class pagePanel extends JPanel {
  selectPanel parent;
  JTextField page;
  JCheckBox prefix;
  
  static int pageColumns = 15;

  public pagePanel(selectPanel target) {
    this.parent = target;
    setLayout(new FlowLayout(FlowLayout.CENTER, 5, 0));

    Border empty = BorderFactory.createEmptyBorder();
    TitledBorder pageTitle = BorderFactory.createTitledBorder(empty, "Type a page");
    pageTitle.setTitleJustification(TitledBorder.CENTER);
    setBorder(pageTitle);

    page = new JTextField("/textbook/kidsweb/", pageColumns);
    prefix = new JCheckBox("Prefix");
    add(page);
    add(prefix);
  }

  public boolean IsPrefix() {
    return prefix.isSelected();
  }

  public String getCondition() {
    return page.getText();
  }
}

class bottomPanel extends JPanel {
  menu_swing parent;

  barPanel barP;
  buttonPanel btP;

  public bottomPanel(menu_swing target) {
    System.out.println("BottomPanel");
    this.parent = target;
    setLayout(new GridLayout(2, 0));

    barP = new barPanel(this);
    btP = new buttonPanel(this);

    add(barP);
    add(btP);
  }
}

class barPanel extends JPanel {
  bottomPanel parent;
  JProgressBar pBar;

  public barPanel(bottomPanel target) {
    this.parent = target;
    setLayout(new FlowLayout(FlowLayout.CENTER, 5, 10));
    JLabel pBarName = new JLabel("Progress: ");
    pBar = new JProgressBar();
    pBar.setMinimum(0);
    pBar.setMaximum(100);
    pBar.setValue(0);
    add(pBarName);
    add(pBar);
  }
}

class buttonPanel extends JPanel {
  bottomPanel parent;
  JButton b;

  public buttonPanel(bottomPanel target) {
    this.parent = target;
    //System.out.println("ButtonPanel");
    //-setBackground(Color.white);
    setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
    setBorder(BorderFactory.createEmptyBorder(0, 100, 20, 100));
    setLayout(new BorderLayout());
    b = new JButton("Visualize");
    //b.setAlignmentX(Component.CENTER_ALIGNMENT);

    ButtonListener vbuttonListener = new ButtonListener();

    b.setActionCommand("visualize");
    b.addActionListener(vbuttonListener);
    add(b, "Center");
  }

  class ButtonListener implements ActionListener { 
    public void actionPerformed(ActionEvent e) {
      //b.setEnabled(false);
      //parent.parent.stopButton.setEnabled(true);
      parent.parent.execution();
      //b.setEnabled(true);
      //parent.parent.setProgressBar(0);
    }
  }
}
